package de.noahpeeters.gameoflife.classic;

import de.noahpeeters.gameoflife.classic.model.Board;
import de.noahpeeters.gameoflife.classic.model.CellPosition;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;

public class BoardController {
    private Board board;

    public BoardController() {
        this.board = new Board(new HashSet<>(), new HashMap<>());

        this.board.reviveCell(new CellPosition(1, 0));
        this.board.reviveCell(new CellPosition(2, 1));
        this.board.reviveCell(new CellPosition(0, 2));
        this.board.reviveCell(new CellPosition(1, 2));
        this.board.reviveCell(new CellPosition(2, 2));
    }

    public void step() {
        Board newBoard = board.cloneBoard();
        for (CellPosition position: board.getActivePositions()) {
            long aliveNeighbourCount = board.getNeighboursOfPosition(position).stream().filter(board.getAliveCells()::contains).count();
            boolean isAlive = board.getAliveCells().contains(position);

            if (isAlive && (aliveNeighbourCount < 2 || aliveNeighbourCount > 3)) {
                newBoard.getAliveCells().remove(position);
            } else if (!isAlive && aliveNeighbourCount == 3) {
                newBoard.reviveCell(position);
            }
        }
        this.board = newBoard;
    }

    public void print() {
//        for (int y = 0; y < 10; y++) {
//            for (int x = 0; x < 10; x++) {
//                CellPosition cellPosition = new CellPosition(x, y);
//                System.out.print(board.getAliveCells().contains(cellPosition) ? "X" : " ");
//            }
//            System.out.println();
//        }
//        System.out.println("Alive cell #: " + this.board.getAliveCells().size());
//        System.out.println("----------");
//
//        System.out.println(board.aliveCount(new CellPosition(0, 0)));
//        System.out.println(board.aliveCount(new CellPosition(3, 2)));
    }
}
